
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class NonconformancesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.create(
            {
                id: data.id || undefined,
        
        ncr_number: data.ncr_number
        ||
        null
            ,
            
        source: data.source
        ||
        null
            ,
            
        severity: data.severity
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        reported_at: data.reported_at
        ||
        null
            ,
            
        problem_description: data.problem_description
        ||
        null
            ,
            
        containment_actions: data.containment_actions
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await nonconformances.setItem( data.item || null, {
            transaction,
        });
        
        await nonconformances.setLot( data.lot || null, {
            transaction,
        });
        
        await nonconformances.setSerial( data.serial || null, {
            transaction,
        });
        
        await nonconformances.setWork_order( data.work_order || null, {
            transaction,
        });
        
        await nonconformances.setInspection( data.inspection || null, {
            transaction,
        });
        
        await nonconformances.setReported_by( data.reported_by || null, {
            transaction,
        });
        
        await nonconformances.setDisposition_code( data.disposition_code || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.nonconformances.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: nonconformances.id,
            },
            data.attachments,
            options,
        );
        

        return nonconformances;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const nonconformancesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                ncr_number: item.ncr_number
            ||
            null
            ,
            
                source: item.source
            ||
            null
            ,
            
                severity: item.severity
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                reported_at: item.reported_at
            ||
            null
            ,
            
                problem_description: item.problem_description
            ||
            null
            ,
            
                containment_actions: item.containment_actions
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const nonconformances = await db.nonconformances.bulkCreate(nonconformancesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < nonconformances.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.nonconformances.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: nonconformances[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return nonconformances;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const nonconformances = await db.nonconformances.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.ncr_number !== undefined) updatePayload.ncr_number = data.ncr_number;
        
        
        if (data.source !== undefined) updatePayload.source = data.source;
        
        
        if (data.severity !== undefined) updatePayload.severity = data.severity;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.reported_at !== undefined) updatePayload.reported_at = data.reported_at;
        
        
        if (data.problem_description !== undefined) updatePayload.problem_description = data.problem_description;
        
        
        if (data.containment_actions !== undefined) updatePayload.containment_actions = data.containment_actions;
        
        
        updatePayload.updatedById = currentUser.id;

        await nonconformances.update(updatePayload, {transaction});

        
        
        if (data.item !== undefined) {
            await nonconformances.setItem(
              
              data.item,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await nonconformances.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.serial !== undefined) {
            await nonconformances.setSerial(
              
              data.serial,
              
              { transaction }
            );
        }
        
        if (data.work_order !== undefined) {
            await nonconformances.setWork_order(
              
              data.work_order,
              
              { transaction }
            );
        }
        
        if (data.inspection !== undefined) {
            await nonconformances.setInspection(
              
              data.inspection,
              
              { transaction }
            );
        }
        
        if (data.reported_by !== undefined) {
            await nonconformances.setReported_by(
              
              data.reported_by,
              
              { transaction }
            );
        }
        
        if (data.disposition_code !== undefined) {
            await nonconformances.setDisposition_code(
              
              data.disposition_code,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.nonconformances.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: nonconformances.id,
            },
            data.attachments,
            options,
        );
        

        return nonconformances;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of nonconformances) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of nonconformances) {
                await record.destroy({transaction});
            }
        });


        return nonconformances;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findByPk(id, options);

        await nonconformances.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await nonconformances.destroy({
            transaction
        });

        return nonconformances;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findOne(
            { where },
            { transaction },
        );

        if (!nonconformances) {
            return nonconformances;
        }

        const output = nonconformances.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.capa_actions_nonconformance = await nonconformances.getCapa_actions_nonconformance({
            transaction
        });
        
        
        
        
        output.item = await nonconformances.getItem({
            transaction
        });
        
        
        output.lot = await nonconformances.getLot({
            transaction
        });
        
        
        output.serial = await nonconformances.getSerial({
            transaction
        });
        
        
        output.work_order = await nonconformances.getWork_order({
            transaction
        });
        
        
        output.inspection = await nonconformances.getInspection({
            transaction
        });
        
        
        output.reported_by = await nonconformances.getReported_by({
            transaction
        });
        
        
        output.disposition_code = await nonconformances.getDisposition_code({
            transaction
        });
        
        
        output.attachments = await nonconformances.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.items,
        as: 'item',
        
        where: filter.item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.item.split('|').map(term => Utils.uuid(term)) } },
            {
              item_name: {
                [Op.or]: filter.item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.serials,
        as: 'serial',
        
        where: filter.serial ? {
          [Op.or]: [
            { id: { [Op.in]: filter.serial.split('|').map(term => Utils.uuid(term)) } },
            {
              serial_number: {
                [Op.or]: filter.serial.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.work_orders,
        as: 'work_order',
        
        where: filter.work_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.work_order.split('|').map(term => Utils.uuid(term)) } },
            {
              work_order_number: {
                [Op.or]: filter.work_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.inspections,
        as: 'inspection',
        
        where: filter.inspection ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspection.split('|').map(term => Utils.uuid(term)) } },
            {
              inspection_number: {
                [Op.or]: filter.inspection.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'reported_by',
        
        where: filter.reported_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reported_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.reported_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.disposition_codes,
        as: 'disposition_code',
        
        where: filter.disposition_code ? {
          [Op.or]: [
            { id: { [Op.in]: filter.disposition_code.split('|').map(term => Utils.uuid(term)) } },
            {
              disposition_name: {
                [Op.or]: filter.disposition_code.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.ncr_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'ncr_number',
                        filter.ncr_number,
                    ),
                };
            }
            
            if (filter.problem_description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'problem_description',
                        filter.problem_description,
                    ),
                };
            }
            
            if (filter.containment_actions) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'containment_actions',
                        filter.containment_actions,
                    ),
                };
            }
            

            
            

            
            if (filter.reported_atRange) {
                const [start, end] = filter.reported_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.source) {
                where = {
                    ...where,
                source: filter.source,
            };
            }
            
            if (filter.severity) {
                where = {
                    ...where,
                severity: filter.severity,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.nonconformances.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'nonconformances',
                        'ncr_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.nonconformances.findAll({
            attributes: [ 'id', 'ncr_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['ncr_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.ncr_number,
        }));
    }

    
};

